/* $Header: /usr/local/cvs/keyring/src/keyring.h,v 1.3 2002/12/14 00:08:47 BaeLang Exp $ */

#define KEYRING_VERSION "2.2"

#ifndef FALSE
#define FALSE  0
#endif
#ifndef TRUE
#define TRUE  1
#endif

#undef DEBUG
//#define DEBUG

/*
* default values here.
*/
#define CONF_FILE "C:/keyring/keyring.ini"
#define CONF_SIZE 16
#define PROGRAM_NAME "eqgame"
#define OFFSET "0x00000000"
#define SEND_INTERVAL 0
#define ADDRESS "127.0.0.1"
#define PORT "10000"
#define EQ_EXECUTABLE "C:\\Program Files\\Everquest\\eqgame.exe"


/*
* config file structure.  
*/
struct CONFIG {
	char ProgramName[CONF_SIZE];
	unsigned long long SessionKeyLocation;
	unsigned int SendInterval;
	char seq_ip[16];
	int seq_port;
	} config;

/*
* command line options structure
*/
struct options {
	char * ConfFile;
	char ProgramName[CONF_SIZE];
	unsigned long long SessionKeyLocation;
	unsigned int SendInterval;
	char seq_ip[16];
	int seq_port;

	} options;


char * executable_path;
int SendSessionKey(unsigned long long SessionKey);
