#include <winsock2.h>
#include <stdio.h>
#include <string.h>
#include <tlhelp32.h>
#include <time.h>

#include "keyring.h"

/*
* This function makes it so you can run the program anytime 
* without gettting the OpenProcess error 5 message 
*
* shamelessly snarfed from the sourceforge forums by BaeLang
* origionally posted by UncleBen
*
*/
extern unsigned short int verbose;

unsigned short int enable_debug_privs()  {

	/*
	* ok.  i added a comment.  heh
	* i am also adding in a print when in verbose mode
	*/
	if(verbose) {
		printf("UncleBen's function is now running.\n");
		printf("\tattempting to enable debug privledges.\n");
		}

	HANDLE      hToken;     /* process token */
	TOKEN_PRIVILEGES tp;    /* token provileges */
	TOKEN_PRIVILEGES oldtp;    /* old token privileges */
	DWORD    dwSize = sizeof (TOKEN_PRIVILEGES);          
	LUID     luid;

	if (!OpenProcessToken (GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
	{
		if (GetLastError() == ERROR_CALL_NOT_IMPLEMENTED)
			return TRUE;
		printf ("OpenProcessToken() failed: %d\n", GetLastError());
		return FALSE;
	}

	if (!LookupPrivilegeValue (NULL, SE_DEBUG_NAME, &luid))
	{
		printf ("LookupPrivilege() failed: %d\n", GetLastError());
		CloseHandle (hToken);
		return FALSE;
	}

	ZeroMemory (&tp, sizeof (tp));
	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = luid;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

	/* Adjust Token privileges */
	if (!AdjustTokenPrivileges (hToken, FALSE, &tp, sizeof(TOKEN_PRIVILEGES), &oldtp, &dwSize))
	{
		printf ("AdjustTokenPrivileges() failed: %d\n", GetLastError());
		CloseHandle (hToken);
		return FALSE;
	}
        
	return TRUE;
}

